#include<GL/glut.h>
#define N 50
#define INCGRID 5 

GLuint objects;

GLdouble vertex[][3] = {
  { 0.0, 0.0, 0.0 },
  { 1.0, 0.0, 0.0 },
  { 1.0, 1.0, 0.0 },
  { 0.0, 1.0, 0.0 },
  { 0.0, 0.0, 1.0 },
  { 1.0, 0.0, 1.0 },
  { 1.0, 1.0, 1.0 },
  { 0.0, 1.0, 1.0 }
};

int face[][4] = {
  { 0, 1, 2, 3 },
  { 1, 5, 6, 2 },
  { 5, 4, 7, 6 },
  { 4, 0, 3, 7 },
  { 4, 5, 1, 0 },
  { 3, 2, 6, 7 }
};

void cube(void)
{
	int i;
	int j;
	
	glBegin(GL_QUADS);
		for (j = 0; j < 6; j++) {
//			glNormal3dv(normal[j]);
				for (i = 0; i < 4; i++) {
					glVertex3dv(vertex[face[j][i]]);
				}
		}
	glEnd();

}

void display(void)
{
	static GLfloat lightpos[] = {3.0,4.0,5.0,1.0};

	static double ex = -2.0, ez = -30.0;
	static double r = 0.0;

	/* ̥ꥢ */
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	/* ǥӥ塼Ѵν */
	glLoadIdentity();

	/* ΰư */
	glRotated(r,0.0,1.0,0.0);
	glTranslated(ex,-5.0,ez);

	/* ΰ֤  */
	glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
	/*  */
	glCallList(objects);

	glFlush();
}

void resize(int w, int h)
{
	/* ɥΤӥ塼ݡȤˤ*/	
	glViewport(0,0,w,h);
	
	/* ƩѴλ */
	glMatrixMode(GL_PROJECTION);

	/* ƩѴν*/
	glLoadIdentity();
	gluPerspective(30.0,(double)w/ (double)h, 1.0,100.0);

	/* ǥӥ塼Ѵλ */
	glMatrixMode(GL_MODELVIEW);
}

void keyboard(unsigned char key, int x, int y)
{
	/* ECS  q  פ齪λ */
	if(key == '\033' || key == 'q'){
		exit(0);
	}
}

void scene(void)
{
	/* ʪΤο */
	static GLfloat red[] = { 0.8, 0.2, 0.2, 1.0 };
	static GLfloat green[] = { 0.2, 0.8, 0.2, 1.0 };
	static GLfloat blue[] = { 0.2, 0.2, 0.8, 1.0 };
	static GLfloat yellow[] = { 0.8, 0.8, 0.2, 1.0 };
	static GLfloat ground[][4] = {
				{ 0.6, 0.6, 0.6, 1.0 },
				{ 0.3, 0.3, 0.3, 1.0 }
							};

	int x;
	float pt[3];
	int i,j;
	
	/* ޷ǥץ쥤ꥹȤϿ */
	objects = glGenLists(1);
	glNewList(objects,GL_COMPILE);
	
	glPushMatrix();
	glTranslated(0.0,1.0,0.0);
	glMaterialfv(GL_FRONT,GL_DIFFUSE,red);
	glutSolidCube(1.0);
	glPopMatrix();

	glPushMatrix();
	glTranslated(-3.0,1.0,3.0);
	glMaterialfv(GL_FRONT,GL_DIFFUSE,blue);
	glutSolidCube(1.0);
	glPopMatrix();

	glPushMatrix();
	glTranslated(3.0,1.0,3.0);
	glMaterialfv(GL_FRONT,GL_DIFFUSE,green);
	glutSolidCube(1.0);
	glPopMatrix();
	
	glPushMatrix();
	glTranslated(3.0,1.0,2.0);
	cube();
	glPopMatrix();
	
        glColor3ub(255,255,0);
        for(x = -N; x <= N; x+=INCGRID)
        {
                glBegin(GL_LINE_STRIP);
                pt[0] = x; pt[1] = 0; pt[2] = -N;
                glVertex3fv(pt);
                pt[0] = x; pt[1] = 0; pt[2] = N;
                glVertex3fv(pt);
                glEnd();

                glBegin(GL_LINE_STRIP);
                pt[0] = -N; pt[1] = 0;pt[2] = x;
                glVertex3fv(pt);
                pt[0] = N; pt[1] = 0; pt[2] = x;
                glVertex3fv(pt);
                glEnd();
        }
	
	/*  */
/*	glBegin(GL_QUADS);
	glNormal3d(0.0, 1.0, 0.0);
		for (j = -5; j < 5; j++) {
		for (i = -5; i < 5; i++) {
			glMaterialfv(GL_FRONT, GL_DIFFUSE, ground[(i + j) & 1]);
			glVertex3d((GLdouble)i, -0.5, (GLdouble)j);
			glVertex3d((GLdouble)i, -0.5, (GLdouble)(j + 1));
			glVertex3d((GLdouble)(i + 1), -0.5, (GLdouble)(j + 1));
			glVertex3d((GLdouble)(i + 1), -0.5, (GLdouble)j);
		}
		}
*/

	glEndList();

}

void init(void)
{
	/**/
	glClearColor(1.0,1.0,1.0,0.0);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_CULL_FACE);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
}

int main(int argc ,char *argv[])
{
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH);
	glutInitWindowSize(600,600);
	glutInitWindowPosition(0,0);
	glutCreateWindow(argv[0]);
	glutDisplayFunc(display);	
	glutReshapeFunc(resize);
	glutKeyboardFunc(keyboard);
	scene();
	init();
	glutMainLoop();
	return 0;
}
